Debian Bug report logs - #242255
lvm2 does not work with devfs

version graph

Package: lvm2; Maintainer for lvm2 is Debian LVM Team <pkg-lvm-maintainers@lists.alioth.debian.org>; Source for lvm2 is src:lvm2.

Reported by: Norbert Veber <nveber@pyre.virge.net>

Date: Mon, 5 Apr 2004 15:48:02 UTC

Severity: important

Found in version 2.00.08-4

Fixed in version 2.00.19-1

Done: Bastian Blank <waldi@debian.org>

Bug is archived. No further changes may be made.

Toggle useless messages

View this report as an mbox folder, status mbox, maintainer mbox


Report forwarded to debian-bugs-dist@lists.debian.org, Andres Salomon <dilinger@voxel.net>:
Bug#242255; Package lvm2. Full text and rfc822 format available.

Acknowledgement sent to Norbert Veber <nveber@pyre.virge.net>:
New Bug report received and forwarded. Copy sent to Andres Salomon <dilinger@voxel.net>. Full text and rfc822 format available.

Message #5 received at submit@bugs.debian.org (full text, mbox):

From: Norbert Veber <nveber@pyre.virge.net>
To: Debian Bug Tracking System <submit@bugs.debian.org>
Subject: lvm2 does not work with devfs
Date: Mon, 05 Apr 2004 11:32:59 -0400
Package: lvm2
Version: 2.00.08-4
Severity: important

Hi,

If you have devfs mounted on /dev, most lvm2 commands take about 5
minutes to execute.  vgcfgbackup (which is run from the postinst)
segfaulted when I first installed the package.  I later purged and
re-installed, at which point the postinst got stuck on vgcfgbackup.  An
strace revealed that it was in an inifinte loop traversing /dev.

The other problem is that when you run vgcreate, a directory for the
volume group is not created.  For instance if I try to create vg00, and
then a "test" lv under it, both commands complete sucessfully, but there
will be no /dev/vg00/test device.  At this point its impossible to use
the logical volume, or to even remove it.  The lvremove command insists
on being given a device name, except no device name exists.

Once I booted with devfs disabled, everything worked fine.

It looks like lvm2 was not designed with devfs in mind.  The package
should detect the presence of devfs, and refuse to install, or at least
give a warning to the user.

-- System Information:
Debian Release: testing/unstable
  APT prefers unstable
  APT policy: (500, 'unstable')
Architecture: i386 (i686)
Kernel: Linux 2.6.4-1-k7
Locale: LANG=en_US.UTF-8, LC_CTYPE=en_US.UTF-8

Versions of packages lvm2 depends on:
ii  libc6                       2.3.2.ds1-11 GNU C Library: Shared libraries an
ii  libdevmapper1.00            2:1.00.07-4  The Linux Kernel Device Mapper use
ii  lvm-common                  1.5.12       The Logical Volume Manager for Lin

-- no debconf information



Information forwarded to debian-bugs-dist@lists.debian.org:
Bug#242255; Package lvm2. Full text and rfc822 format available.

Acknowledgement sent to Andres Salomon <dilinger@voxel.net>:
Extra info received and forwarded to list. Full text and rfc822 format available.

Message #10 received at 242255@bugs.debian.org (full text, mbox):

From: Andres Salomon <dilinger@voxel.net>
To: Norbert Veber <nveber@pyre.virge.net>, 242255@bugs.debian.org
Subject: Re: Bug#242255: lvm2 does not work with devfs
Date: Mon, 05 Apr 2004 12:03:04 -0400
[Message part 1 (text/plain, inline)]
On Mon, 2004-04-05 at 11:32, Norbert Veber wrote:
> Package: lvm2
> Version: 2.00.08-4
> Severity: important
> 
> Hi,
> 
> If you have devfs mounted on /dev, most lvm2 commands take about 5
> minutes to execute.  vgcfgbackup (which is run from the postinst)
> segfaulted when I first installed the package.  I later purged and

Neat.


> re-installed, at which point the postinst got stuck on vgcfgbackup.  An
> strace revealed that it was in an inifinte loop traversing /dev.
> 

Any chance you can track down exactly what directory it's looping?  I
haven't seen this happen (and I run devfs pretty much everywhere) yet.
Either way, I'll commit some code upstream to ensure that when
traversing directories, an infinite loop can't happen (if it hasn't
already been done).


> The other problem is that when you run vgcreate, a directory for the
> volume group is not created.  For instance if I try to create vg00, and
> then a "test" lv under it, both commands complete sucessfully, but there
> will be no /dev/vg00/test device.  At this point its impossible to use
> the logical volume, or to even remove it.  The lvremove command insists
> on being given a device name, except no device name exists.
> 

I'm betting the problem here is Xu's 2.6.4 kernel package. 
Unfortunately, the dm-mod that is provided is incomplete.  I need to
play around w/ his 2.6.4, though.


> Once I booted with devfs disabled, everything worked fine.
> 
> It looks like lvm2 was not designed with devfs in mind.  The package
> should detect the presence of devfs, and refuse to install, or at least
> give a warning to the user.

It definitely was designed w/ devfs in mind; however, I suspect that 2.6
has changed some things around.


> 
> -- System Information:
> Debian Release: testing/unstable
>   APT prefers unstable
>   APT policy: (500, 'unstable')
> Architecture: i386 (i686)
> Kernel: Linux 2.6.4-1-k7
> Locale: LANG=en_US.UTF-8, LC_CTYPE=en_US.UTF-8
> 
> Versions of packages lvm2 depends on:
> ii  libc6                       2.3.2.ds1-11 GNU C Library: Shared libraries an
> ii  libdevmapper1.00            2:1.00.07-4  The Linux Kernel Device Mapper use
> ii  lvm-common                  1.5.12       The Logical Volume Manager for Lin
> 
> -- no debconf information
> 
[signature.asc (application/pgp-signature, inline)]

Information forwarded to debian-bugs-dist@lists.debian.org, Andres Salomon <dilinger@voxel.net>:
Bug#242255; Package lvm2. Full text and rfc822 format available.

Acknowledgement sent to Norbert Veber <nveber@debian.org>:
Extra info received and forwarded to list. Copy sent to Andres Salomon <dilinger@voxel.net>. Full text and rfc822 format available.

Message #15 received at 242255@bugs.debian.org (full text, mbox):

From: Norbert Veber <nveber@debian.org>
To: Andres Salomon <dilinger@voxel.net>
Cc: 242255@bugs.debian.org
Subject: Re: Bug#242255: lvm2 does not work with devfs
Date: Mon, 5 Apr 2004 17:47:01 -0400
On Mon, Apr 05, 2004 at 12:03:04PM -0400, Andres Salomon wrote:
> > re-installed, at which point the postinst got stuck on vgcfgbackup.  An
> > strace revealed that it was in an inifinte loop traversing /dev.
> > 
> Any chance you can track down exactly what directory it's looping?  I
> haven't seen this happen (and I run devfs pretty much everywhere) yet.
> Either way, I'll commit some code upstream to ensure that when
> traversing directories, an infinite loop can't happen (if it hasn't
> already been done).

This is the only part of the strace I have saved:
lstat64("/dev/discs/disc10/discs/disc10/discs/disc10/discs/disc10/discs/disc10/discs", {st_mode=S_IFDIR|0755, st_size=0, ...}) = 0
lstat64("/dev/discs/disc10/discs/disc10/discs/disc10/discs/disc10/discs/disc10/discs", {st_mode=S_IFDIR|0755, st_size=0, ...}) = 0
lstat64("/dev/discs/disc10/discs/disc10/discs/disc10/discs/disc10/discs/disc10/discs/disc10", {st_mode=S_IFLNK|0555, st_size=3, ...}) = 0
lstat64("/dev/discs/disc10/discs/disc10/discs/disc10/discs/disc10/discs/disc10/discs/disc10", {st_mode=S_IFLNK|0555, st_size=3, ...}) = 0
lstat64("/dev/discs/disc10/discs/disc10/discs/disc10/discs/disc10/discs/disc10/discs/disc10/discs", {st_mode=S_IFDIR|0755, st_size=0, ...}) = 0

It may be that the loop ends at some point, and then it moves on to the
next disc.  It ran for about 10 minutes at which point I just killed it.
:)

> > The other problem is that when you run vgcreate, a directory for the
> > volume group is not created.  For instance if I try to create vg00, and
> > then a "test" lv under it, both commands complete sucessfully, but there
> > will be no /dev/vg00/test device.  At this point its impossible to use
> > the logical volume, or to even remove it.  The lvremove command insists
> > on being given a device name, except no device name exists.
> > 
> 
> I'm betting the problem here is Xu's 2.6.4 kernel package. 
> Unfortunately, the dm-mod that is provided is incomplete.  I need to
> play around w/ his 2.6.4, though.

Yes, I am using the debian 2.6.4 kernel.

Are you saying that vanilla 2.6.4 has a more complete dm-mod than
Herbert's package?  Why would he remove functionality?

Thanks,

Norbert



Information forwarded to debian-bugs-dist@lists.debian.org:
Bug#242255; Package lvm2. Full text and rfc822 format available.

Acknowledgement sent to Andres Salomon <dilinger@voxel.net>:
Extra info received and forwarded to list. Full text and rfc822 format available.

Message #20 received at 242255@bugs.debian.org (full text, mbox):

From: Andres Salomon <dilinger@voxel.net>
To: Norbert Veber <nveber@debian.org>, 242255@bugs.debian.org
Subject: Re: Bug#242255: lvm2 does not work with devfs
Date: Mon, 05 Apr 2004 21:33:53 -0400
[Message part 1 (text/plain, inline)]
On Mon, 2004-04-05 at 17:47, Norbert Veber wrote:
[...]
> 
> Yes, I am using the debian 2.6.4 kernel.
> 
> Are you saying that vanilla 2.6.4 has a more complete dm-mod than
> Herbert's package?  Why would he remove functionality?
> 

Sorry, brain fart.  2.6 contains the complete (incomplete) dm-mod. 
2.6's dm does not support snapshots, and a few other things.  Xu's 2.4
kernel is the one w/ the incomplete dm-mod.  2.6's dm-mod is also
incomplete, but that's upstream's fault.


> Thanks,
> 
> Norbert
> 
[signature.asc (application/pgp-signature, inline)]

Information forwarded to debian-bugs-dist@lists.debian.org, Andres Salomon <dilinger@voxel.net>:
Bug#242255; Package lvm2. Full text and rfc822 format available.

Acknowledgement sent to Brian Morris <brian.morris@recurse.net>:
Extra info received and forwarded to list. Copy sent to Andres Salomon <dilinger@voxel.net>. Full text and rfc822 format available.

Message #25 received at 242255@bugs.debian.org (full text, mbox):

From: Brian Morris <brian.morris@recurse.net>
To: 242255@bugs.debian.org
Subject: lvm2, devfs, partitioned raid devices
Date: Sun, 02 May 2004 16:09:30 -0700
Hi,

I also have been having trouble with LVM2, 2.6.4+, and devfs.  Is this a 
combination that is going to be supported at some point?  I was 
encouraged to find someone else had the same problem I was having when I 
looked into this a few weeks ago, but it doesn't seem that there has 
been any new activity on this recently.  I was hoping I would be able to 
run devfs, but as it is now I am stuck at 2.6.3 since anything after 
that breaks in the manner described in this bug (endless looping in 
/dev/discs).  For some reason, 2.6.4+ seems to create all discXXX 
entries, and anything beyond the discs that actually exist point to ".." 
and thus create endless recursion.

In my investigation of this problem, though, I am not primarily seeing 
that failure mode anymore (maybe a recent update of one of the packages 
fixed it) but I AM seeing another failure.  I am getting a segfault when 
vgscan tries to read the new /dev/md/dXXX devices (partitioned raids?).  
I captured the following strace from a vgscan running in the initrd 
during a 2.6.5 boot:

open("/dev/md/d0", O_RDONLY)            = 4
close(4)                                = 0
stat64("/dev/md/d0", {st_mode=S_IFBLK|0600, st_rdev=makedev(254, 0), 
...}) = 0
stat64("/dev/md/d0", {st_mode=S_IFBLK|0600, st_rdev=makedev(254, 0), 
...}) = 0
open("/dev/md/d0", O_RDWR|O_DIRECT)     = 4
fstat64(4, {st_mode=S_IFBLK|0600, st_rdev=makedev(254, 0), ...}) = 0
ioctl(4, 0x80041270, 0xbffff1ac)        = 0
lseek(4, 0, SEEK_SET)                   = 0
read(4, "", 4096)                       = 0
close(4)                                = 0
--- SIGSEGV (Segmentation fault) @ 0 (0) ---
+++ killed by SIGSEGV +++

I also get "devfs_mk_dir: invalid argument" when it dies.

I am not sure if this is a different issue (and should be filed as a 
separate bug) but in any case, I am still unable to boot my system with 
2.6.4 or later (though 2.6.3 still works just fine with the same 
userspace tools).

A little more info on my system:
root on LVM
boot partition outside LVM on /dev/hda1
using initrd (which in itself took some tweaks to get working with lvm2)
two volume groups, both migrated to lvm2 metadata:
sys_vg on /dev/hda3   (includes /, /var, /usr)
data_vg on /dev/md0  (some data partitions)

Do I need to disable devfs?  Can anything be done for either of these 
problems?

Thanks.

--
Brian Morris -- brian.morris@recurse.net
Computer Engineer [March 2003, Cal Poly, San Luis Obispo, CA]





Information forwarded to debian-bugs-dist@lists.debian.org:
Bug#242255; Package lvm2. Full text and rfc822 format available.

Acknowledgement sent to Andres Salomon <dilinger@voxel.net>:
Extra info received and forwarded to list. Full text and rfc822 format available.

Message #30 received at 242255@bugs.debian.org (full text, mbox):

From: Andres Salomon <dilinger@voxel.net>
To: 242255@bugs.debian.org, brian.morris@recurse.net, Norbert Veber <nveber@pyre.virge.net>
Subject: Re: Bug#242255: lvm2 does not work with devfs
Date: Mon, 10 May 2004 12:21:31 -0400
[Message part 1 (text/plain, inline)]
Hi,

This bug (lvm2 looping and then crashing inside /dev when devfs is used
in 2.6) should have been fixed with the latest lvm2 upload.  Can you
please upgrade, try it out, and report whether it's succesful or not?

[signature.asc (application/pgp-signature, inline)]

Information forwarded to debian-bugs-dist@lists.debian.org, Andres Salomon <dilinger@voxel.net>:
Bug#242255; Package lvm2. Full text and rfc822 format available.

Acknowledgement sent to Brian Morris <brian@recurse.net>:
Extra info received and forwarded to list. Copy sent to Andres Salomon <dilinger@voxel.net>. Full text and rfc822 format available.

Message #35 received at 242255@bugs.debian.org (full text, mbox):

From: Brian Morris <brian@recurse.net>
To: Andres Salomon <dilinger@voxel.net>, 242255@bugs.debian.org
Subject: Re: Bug#242255: lvm2 does not work with devfs
Date: Mon, 10 May 2004 21:59:46 -0700
Hi,

I updated to the latest lvm2 in the unstable branch, and even updated to
the latest libdevmapper (though this wasn't automatically done by
apt-get) but I still get segfaults when vgscan and vgchange run from the
initrd on boot.  (I did regenerate the initrd with lvmcreate_initrd.)

Since I don't have a good way to copy this, I'm going to manually type
the interesting parts of the boot process prior to the kernel panic that
occurs when it can't find the root fs:

= = = = =

VFS: Mounted root (ext2 filesystem).
Mounted devfs on /dev
  Reading all physical volumes.  This may take a while...
devfs_mk_dir: invalid argument./linuxrc: line 3:    22 Segmentation fault     /sbin/vgscan
/linuxrc: line 4:    23 Segmentation fault     /sbin/vgchange -a y
VFS: Cannot open root device "sys_vg/root" or unknown-block(0,0)

= = = = =

This is no different than it was prior to the latest update.

I also verified that, as best I can tell, the initrd and my main system
now both have the latest lvm2 files.  The files in the initrd are the
same as the ones on my system partitions (under LVM), and debian
reports:

ii  lvm2                          2.00.15-2                     The Linux Logical Volume Manager

And this is the same version that was listed in the emails I received
about the package.

So... I haven't bothered to collect new strace dumps or repeat any of
the investigation I had done before, but this problem doesn't seem to
have changed.

On Mon, May 10, 2004 at 12:21:31PM -0400, Andres Salomon wrote:
> This bug (lvm2 looping and then crashing inside /dev when devfs is used
> in 2.6) should have been fixed with the latest lvm2 upload.  Can you
> please upgrade, try it out, and report whether it's succesful or not?

-- 
Brian Morris -- brian@recurse.net -- 408/219-4450
Computer Engineer [March 2003, Cal Poly, San Luis Obispo, CA]



Bug 242255 cloned as bug 248477. Request was from Andres Salomon <dilinger@voxel.net> to control@bugs.debian.org. Full text and rfc822 format available.

Information forwarded to debian-bugs-dist@lists.debian.org:
Bug#242255; Package lvm2. Full text and rfc822 format available.

Acknowledgement sent to Patrick Caulfield <patrick@debian.org>:
Extra info received and forwarded to list. Full text and rfc822 format available.

Message #42 received at 242255@bugs.debian.org (full text, mbox):

From: Patrick Caulfield <patrick@debian.org>
To: 242255@bugs.debian.org
Subject: RE: lvm2 does not work with devfs
Date: Wed, 7 Jul 2004 15:37:50 +0100
This bug looks identical to #248477 to me and so should be fixed in 2.00.19 -
any chance someone could check so I can maybe close the bug ? thanks.
-- 

patrick



Message sent on to Norbert Veber <nveber@pyre.virge.net>:
Bug#242255. Full text and rfc822 format available.

Message #45 received at 242255-submitter@bugs.debian.org (full text, mbox):

From: Andres Salomon <dilinger@debian.org>
To: Brian Morris <brian.morris@recurse.net>, 242255-submitter@bugs.debian.org
Subject: Re: lvm2 does not work with devfs
Date: Tue, 26 Apr 2005 06:18:11 -0400
[Message part 1 (text/plain, inline)]
Hi,

Patrick reported that this bug should be fixed in lvm2-2.00.19.  Can you
please let us know whether it's still an issue for you?

-- 
Andres Salomon <dilinger@debian.org>
[signature.asc (application/pgp-signature, inline)]

Information stored:
Bug#242255; Package lvm2. Full text and rfc822 format available.

Acknowledgement sent to Norbert Veber <nveber@debian.org>:
Extra info received and filed, but not forwarded. Full text and rfc822 format available.

Message #50 received at 242255-quiet@bugs.debian.org (full text, mbox):

From: Norbert Veber <nveber@debian.org>
To: Andres Salomon <dilinger@debian.org>, 242255-quiet@bugs.debian.org
Subject: Re: Bug#242255: lvm2 does not work with devfs
Date: Tue, 26 Apr 2005 10:43:22 -0400
On Tue, Apr 26, 2005 at 06:18:11AM -0400, Andres Salomon wrote:
> Patrick reported that this bug should be fixed in lvm2-2.00.19.  Can you
> please let us know whether it's still an issue for you?

I have actually stopped using devfs quite a while ago.  It could be a
while before I can re-enable and test it, but feel free to close the bug
if other people aren't seeing the problem..

Thanks,

Norbert



Message sent on to Norbert Veber <nveber@pyre.virge.net>:
Bug#242255. Full text and rfc822 format available.

Message #53 received at 242255-submitter@bugs.debian.org (full text, mbox):

From: Brian Morris <recurse.net@gmail.com>
To: Andres Salomon <dilinger@debian.org>
Cc: 242255-submitter@bugs.debian.org
Subject: Re: lvm2 does not work with devfs
Date: Tue, 26 Apr 2005 16:04:46 -0700
This was the fix that was made a while ago, right?

I have been running with a kernel above 2.6.4 for a little while now,
and I am still using devfs, so I believe this is resolved.  I
currently have lvm2 version 2.01.04-3 installed and I'm running 2.6.9,
and my system can boot fine now.

However, it's been a while since I created my initrd so I remember for
sure if I had to do anything special to get that to work.  I know it's
possible to get things working, at least, which wasn't the case with
the older lvm package.

Thanks.

On 4/26/05, Andres Salomon <dilinger@debian.org> wrote:
> Hi,
> 
> Patrick reported that this bug should be fixed in lvm2-2.00.19.  Can you
> please let us know whether it's still an issue for you?
> 
> --
> Andres Salomon <dilinger@debian.org>
> 
> 
> 
-- 
Brian Morris
Computer Engineer
www.recurse.net



Reply sent to Bastian Blank <waldi@debian.org>:
You have taken responsibility. Full text and rfc822 format available.

Notification sent to Norbert Veber <nveber@pyre.virge.net>:
Bug acknowledged by developer. Full text and rfc822 format available.

Message #58 received at 242255-done@bugs.debian.org (full text, mbox):

From: Bastian Blank <waldi@debian.org>
To: 242255-done@bugs.debian.org
Subject: fixed
Date: Wed, 28 Sep 2005 18:14:06 +0200
[Message part 1 (text/plain, inline)]
Version: 2.00.19-1

The submitter describes this bug as fixed, closing.

Bastian

-- 
Each kiss is as the first.
		-- Miramanee, Kirk's wife, "The Paradise Syndrome",
		   stardate 4842.6
[signature.asc (application/pgp-signature, inline)]

Bug archived. Request was from Debbugs Internal Request <owner@bugs.debian.org> to internal_control@bugs.debian.org. (Mon, 25 Jun 2007 22:33:02 GMT) Full text and rfc822 format available.

Send a report that this bug log contains spam.


Debian bug tracking system administrator <owner@bugs.debian.org>. Last modified: Wed Apr 16 17:02:30 2014; Machine Name: beach.debian.org

Debian Bug tracking system
Copyright (C) 1999 Darren O. Benham, 1997,2003 nCipher Corporation Ltd, 1994-97 Ian Jackson.